package asclass
{
	import asclass.events.AnnounceEvent;
	
	import flash.events.DatagramSocketDataEvent;
	import flash.net.DatagramSocket;
	import flash.net.InterfaceAddress;
	import flash.net.NetworkInfo;
	import flash.net.NetworkInterface;
	import flash.utils.ByteArray;
	
	[Event(name="foundledcontroller", type="asclass.events.AnnounceEvent")]
	
	[Bindable]
	public class AnnounceFinder extends DatagramSocket
	{
		public static const ANNOUNCE_PORT:int = 30303;
		
		private var _recievedIP:String = "none";
		private var _ipUpdated:Boolean = false;
		
		public function AnnounceFinder()
		{
			super();
			this.addEventListener(DatagramSocketDataEvent.DATA,gotData);
			
		}
		
		public function get recievedIP():String
		{
			return _recievedIP;
		}
		public function set recievedIP(val:String):void
		{
			_recievedIP = val;
		}
		public function get ipUpdated():Boolean
		{
			return _ipUpdated;
		}
		public function set ipUpdated(val:Boolean):void
		{
			_ipUpdated = val;
		}
		
		private function gotData(event:DatagramSocketDataEvent):void
		{
			 if (event.data.toString().search("LEDCONTROL") > -1)
			 {
		     	this.recievedIP = event.srcAddress;
				this.ipUpdated = true;
				var an_event:AnnounceEvent = new AnnounceEvent(AnnounceEvent.FOUND_LED_CONTROLLER);
				this.dispatchEvent(an_event);
			 }
		}
		

		public function listenForAnnounce():void
		{
			this.bind(ANNOUNCE_PORT);
			this.receive();
		}
		public function requestAnnounce():void
		{
			var networkInfo:NetworkInfo = NetworkInfo.networkInfo; 
			var interfaces:Vector.<NetworkInterface> = networkInfo.findInterfaces(); 
			var bytes:ByteArray = new ByteArray();
			bytes.writeUTFBytes("Discovery");
			for each (var nInterface:NetworkInterface in interfaces)
			{
				if (nInterface.active)
				{
					for each (var address:InterfaceAddress in nInterface.addresses)
					{
						if (address.broadcast.length > 6)
						{
							this.send(bytes,0,bytes.length,address.broadcast,ANNOUNCE_PORT);
						}
					}
				}
			}
		}
	}
}