package asclass
{
	import mx.collections.IList;
	import mx.utils.StringUtil;
	import mx.validators.ValidationResult;
	import mx.validators.Validator;
	
	public class I2CAddressValidator extends Validator
	{
		
		public var notANumberErrorMessage:String = "Entry could not be parsed as a number";
		public var addressNotEvenErrorMessage:String = "An I2C address must be even";
		public var addressOutOfRangeErrorMessage:String = "An I2C address must be a positive integer less than 254";
		public var existingAddressErrorMessage:String = "That address already exisits";
		
		public var existingAddressCollection:IList = null;
		public var existingAddressField:String = null;
		
		public function I2CAddressValidator()
		{
			super();
		}
		override protected function doValidation(value:Object):Array
		{
			var stringToValidate:String = value.toString();
			stringToValidate = StringUtil.trim(stringToValidate);
			var resultsArray:Array = new Array();
			if (!this.required)
			{
				if (stringToValidate.length == 0)
				{
					return resultsArray;
				}
			}
			if (stringToValidate.length == 0)
			{
				var valResult:ValidationResult = new ValidationResult(true, "", "", this.requiredFieldError);
				resultsArray.push(valResult);
				return resultsArray
			}
			var toInt:Number = parseInt(stringToValidate);
			if (isNaN(toInt))
			{
				var valResult2:ValidationResult = new ValidationResult(true, "", "", notANumberErrorMessage);
				resultsArray.push(valResult2);
			}
			else
			{
				if ((toInt % 2) != 0)
				{
					var valResult3:ValidationResult = new ValidationResult(true, "", "", addressNotEvenErrorMessage);
					resultsArray.push(valResult3);
				}
				if (toInt > 254 || toInt < 2)
				{
					var valResult4:ValidationResult = new ValidationResult(true, "", "", addressOutOfRangeErrorMessage);
					resultsArray.push(valResult4);
				}
				if (existingAddressCollection != null && existingAddressField != null)
				{
					for each (var item:Object in existingAddressCollection)
					{
						if (parseInt(item[existingAddressField]) == toInt)
						{
							var valResult5:ValidationResult = new ValidationResult(true, "", "", existingAddressErrorMessage);
							resultsArray.push(valResult5);
							break;
						}
					}
				}
			}
			
			
			return resultsArray;
			
		}
	}
}