package asclass
{
	import flashx.textLayout.formats.TextAlign;
	
	import mx.graphics.SolidColor;
	import mx.graphics.SolidColorStroke;
	
	import spark.components.Group;
	import spark.components.Label;
	import spark.primitives.Rect;
	
	public class LightBar extends Group
	{
		private var box:Rect;
		private var boxStroke:SolidColorStroke;
		private var boxFill:SolidColor;
		
		private var _text:String = "";
		
		private var _lightColor:uint;
		
		private var textLabel:Label;
		

		public function LightBar()
		{
			super();
			boxStroke = new SolidColorStroke(0,1);
			boxFill = new SolidColor(0);
			box = new Rect();
			box.fill = boxFill;
			box.stroke = boxStroke;
			box.width = 100;
			box.height = 40;
			this.addElement(box);
			
			textLabel = new Label();
			textLabel.setStyle("textAlign", TextAlign.CENTER);
			this.addElement(textLabel);
			
			this.buttonMode = true;

		}
		
		public function get text():String
		{
			return _text;
		}

		public function set text(value:String):void
		{
			_text = value;
			textLabel.text = value;
		}

		public function get lightColor():uint
		{
			return _lightColor;
		}

		public function set lightColor(value:uint):void
		{
			_lightColor = value;
			boxFill.color = value;
		}

		override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			box.width = this.width - 6;
			box.height = this.height - 6;
			box.x = 3;
			box.y = 3;
			textLabel.width = box.width;
			textLabel.x = 3;
			textLabel.y = (this.height - textLabel.height) / 2;
			super.updateDisplayList(unscaledWidth, unscaledHeight);

		}
		
	}
}